drop table agroup;
create table agroup(id integer, somedata integer, primary key (id));

drop table asubgroup;
create table asubgroup(id integer, idgroup integer, somedata integer, primary key (id, idgroup));
alter table asubgroup add foreign key (idgroup) references agroup;

drop table benchtime;
create table benchtime(id integer, objname varchar(20), benchtime time, primary key (id));

drop function bench(integer, integer);
create function bench(integer, integer) returns time as '
declare
	n_group alias for $1;
	n_subgroup alias for $2;
	starttime time;
	endtime time;
	starttimemark time;
	currtimemark time;
	i integer;
	j integer;
begin
	delete from asubgroup;
	delete from agroup;
	delete from benchtime;
	select timeofday()::timestamp::time into starttime;
	starttimemark := starttime;
	for i in 1..n_group loop
		insert into agroup (id, somedata) values (i, random()*n_group);
		for j in 1..n_subgroup loop
			insert into asubgroup (id, idgroup, somedata) values (j, i, random()*n_subgroup);
		end loop;
		select timeofday()::timestamp::time into currtimemark;
		endtime := currtimemark - starttimemark;
		insert into benchtime (id, objname, benchtime) values (i, ''group ''||i, endtime);
		starttimemark := currtimemark;
		raise notice ''create group %'', i;
	end loop;
	select timeofday()::timestamp::time into endtime;
	return endtime - starttime;
end;' language 'plpgsql';
